<template>
    <PdNumericInput
        v-bind="{ ...$attrs, ...$props }"
        v-model="internalValue"
        :min="min"
        :max="max"
        :thousand-separator="thousandSeparator"
        :decimal-separator="decimalSeparator"
        :precision="precision"
        :currency="currency"
        :currency-symbol-position="currencySymbolPosition"
        :output-type="outputType"
    ></PdNumericInput>
</template>

<script setup lang="ts">
import { ref, defineProps, watch, onBeforeMount } from 'vue';
import PdNumericInput from '@/components/base/PdNumericInput.vue';

const props = defineProps({
    modelValue: {
        type: [Number, String],
        default: undefined,
    },
    outputType: {
        type: [Number, String],
        default: Number,
    },
    min: {
        type: Number,
        default: 0,
    },
    max: {
        type: Number,
        default: 1000000000,
    },
    thousandSeparator: {
        type: String,
        default: '.',
    },
    decimalSeparator: {
        type: String,
        default: ',',
    },
    precision: {
        type: Number,
        default: 2,
    },
    isCurrency: {
        type: Boolean,
        default: false,
    },
    currencySymbolPosition: {
        type: String,
        default: 'prefix',
    },
});

const internalValue = ref(props.modelValue);
const currency = ref('');

onBeforeMount(() => {
    if (props.isCurrency) {
        currency.value = '€';
    }
});

// Watch for changes in the value prop and update the internalValue accordingly
watch(
    () => props.modelValue,
    (newValue) => {
        if (typeof newValue === 'string') {
            newValue = parseFloat(newValue);
        }
        internalValue.value = newValue;
    }
);
</script>
